/*
 *   $Id: slist.h,v 1.13 2002/11/29 22:23:17 ondrap Exp $
 *
 *   Scientific Calculator for Palms and PilmPilots.
 *   Copyright (C) 1999,2000,2001 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *  You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _LIST_H_
#define _LIST_H_

#define LIST_INPUT      1000
#define LIST_MIN        1001
#define LIST_MAX        1002
#define LIST_MEAN       1003
#define LIST_SUM        1004
#define LIST_MEDIAN     1005
#define LIST_SORTA      1006
#define LIST_SORTD      1007
#define LIST_GMEAN      1008
#define LIST_PROD       1009
#define LIST_VARIANCE   1010
#define LIST_STDDEV     1011
#define LIST_LINREG     1012
#define LIST_DIM        1013
#define LIST_CUMSUM     1014
#define LIST_MODE       1015
#define LIST_MOMENT     1016
#define LIST_SKEWNESS   1017
#define LIST_KURTOSIS   1018
#define LIST_VARCOEF    1019
#define LIST_RAND       1020
#define LIST_RNORM      1021
#define LIST_RANGE      1022
#define LIST_RTOP       1023
#define LIST_PTOR       1024

List * list_new(Int16 size) NEWFUNC;
List * list_dup(List *oldlist) NEWFUNC;
CError list_input(Functype *func,CodeStack *stack) NEWFUNC;
void list_delete(List *lst) NEWFUNC;
CError list_func(Functype *func,CodeStack *stack) NEWFUNC;
CError list_func2(Functype *func,CodeStack *stack) NEWFUNC;
CError list_stat(Functype *func,CodeStack *stack) NEWFUNC;
CError list_regr(Functype *func,CodeStack *stack) NEWFUNC;
CError list_rand(Functype *func,CodeStack *stack) NEWFUNC;
CError list_item(Functype *func, CodeStack *stack) NEWFUNC;
CError list_range(Functype *func, CodeStack *stack) NEWFUNC;
CError list_mathem(Functype *func, CodeStack *stack) NEWFUNC;

#endif
